#include "globals.h"

static Widget tf1, tf2;
static char tmpPassword[100];

void infoCB( 
#if NeedFunctionPrototypes
	Widget, XtPointer, XtPointer 
#endif
);
void runInXtermCB( 
#if NeedFunctionPrototypes
	Widget, XtPointer, XtPointer 
#endif
);
void transferTypeCB(
#if NeedFunctionPrototypes
        Widget, XtPointer, XtPointer
#endif
);
void mkdirCB( 
#if NeedFunctionPrototypes
	Widget, XtPointer, XtPointer 
#endif
);
void newFileManagerCB( 
#if NeedFunctionPrototypes
	Widget, XtPointer, XtPointer 
#endif
);
void ftpFileManagerCB(
#if NeedFunctionPrototypes
        Widget, XtPointer, XtPointer
#endif
);
void ftpFileManagerOKCB(
#if NeedFunctionPrototypes
        Widget, XtPointer, XtPointer
#endif
);
void duplicateCB( 
#if NeedFunctionPrototypes
	Widget, XtPointer, XtPointer 
#endif
);
void removeCB( 
#if NeedFunctionPrototypes
	Widget, XtPointer, XtPointer 
#endif
);
void removeOKCB(
#if NeedFunctionPrototypes
        Widget, XtPointer, XtPointer
#endif
);
void doMkdir( 
#if NeedFunctionPrototypes
	Widget, XtPointer, XtPointer 
#endif
);
void updateAllCB(
#if NeedFunctionPrototypes
        Widget, XtPointer, XtPointer
#endif
);
void updateCB(
#if NeedFunctionPrototypes
        Widget, XtPointer, XtPointer
#endif
);
void passwordCB(
#if NeedFunctionPrototypes
        Widget, XtPointer, XtPointer
#endif
);


void createMenubar( f, type )
  struct FileManager *f;
  int type;
{
  XmString xms;
  Widget csFile, pdFile, duplicateButton, mkdirButton, removeButton,
         fileSep1, propertiesButton, quitButton, configButton,
         fileSep2, csHelp, pdHelp, infoButton, 
	 csUtil, pdUtil, delAccButton, csOptions, pdOptions,
	 runInXtermToggle, newFileManagerButton, execCmdButton,
	 ftpFileManagerButton, fileSep3, updateThisFMbutton, updateAllFMbutton;

  /* File */

  csFile = XmCreateCascadeButton( f->menubar, "File", NULL, 0 );
  XtManageChild( csFile );
  pdFile = XmCreatePulldownMenu( f->menubar, "File", NULL, 0 );
  XtVaSetValues( csFile, 
		XmNsubMenuId, pdFile,
                XmNmnemonic, 'F',
                NULL );

  if( type == LOCAL_FILESYSTEM )
  {
    xms = XmStringCreateSimple( "Alt-D" );
    duplicateButton = XtVaCreateManagedWidget( "Duplicate",
                xmPushButtonWidgetClass, pdFile,
                XmNaccelerator, "Alt<Key>D",
                XmNacceleratorText, xms,
                XmNmnemonic, 'c',
                NULL );
    XtAddCallback( duplicateButton, XmNactivateCallback, duplicateCB, (XtPointer)f );
    XmStringFree( xms );

    xms = XmStringCreateSimple( "Ctrl-D" );
    removeButton = XtVaCreateManagedWidget( "Delete...",
                xmPushButtonWidgetClass, pdFile,
                XmNaccelerator, "Ctrl<Key>D",
                XmNacceleratorText, xms,
                XmNmnemonic, 'D',
                NULL );
    XtAddCallback( removeButton, XmNactivateCallback, removeCB, (XtPointer)f );
    XmStringFree( xms );

    xms = XmStringCreateSimple( "Ctrl-A" );
    propertiesButton = XtVaCreateManagedWidget( "Attributes...",
                xmPushButtonWidgetClass, pdFile,
                XmNaccelerator, "Ctrl<Key>A",
                XmNacceleratorText, xms,
                XmNmnemonic, 'A',
                NULL );
    XtAddCallback( propertiesButton, XmNactivateCallback, propertiesCB, (XtPointer)f );
    XmStringFree( xms );

    fileSep2 = XtCreateManagedWidget( "fileSep2",
                xmSeparatorWidgetClass, pdFile, NULL, 0 );

    xms = XmStringCreateSimple( "Alt-C" );
    mkdirButton = XtVaCreateManagedWidget( "Create Directory...",
                xmPushButtonWidgetClass, pdFile,
                XmNaccelerator, "Alt<Key>C",
                XmNacceleratorText, xms,
                XmNmnemonic, "y",
                NULL );
    XtAddCallback( mkdirButton, XmNactivateCallback, mkdirCB, (XtPointer)f );
    XmStringFree( xms );

    fileSep1 = XtCreateManagedWidget( "fileSep1",
                xmSeparatorWidgetClass, pdFile, NULL, 0 );

    xms = XmStringCreateSimple( "Ctrl-U" );
    updateThisFMbutton = XtVaCreateManagedWidget( "Update This File Manager",
                xmPushButtonWidgetClass, pdFile,
                XmNaccelerator, "Ctrl<Key>U",
                XmNacceleratorText, xms,
                XmNmnemonic, 'U',
                NULL );
    XtAddCallback( updateThisFMbutton, XmNactivateCallback, updateCB, (XtPointer)f );
    XmStringFree( xms );

    xms = XmStringCreateSimple( "Alt-U" );
    updateAllFMbutton = XtVaCreateManagedWidget( "Update All File Managers",
                xmPushButtonWidgetClass, pdFile,
                XmNaccelerator, "Alt<Key>U",
                XmNacceleratorText, xms,
                XmNmnemonic, 'f',
                NULL );
    XtAddCallback( updateAllFMbutton, XmNactivateCallback, updateAllCB, NULL );
    XmStringFree( xms );

    fileSep3 = XtCreateManagedWidget( "fileSep3",
                xmSeparatorWidgetClass, pdFile, NULL, 0 );
  }

  xms = XmStringCreateSimple( "Ctrl-Q" );
  quitButton = XtVaCreateManagedWidget( "Quit",
                xmPushButtonWidgetClass, pdFile,
                XmNaccelerator, "Ctrl<Key>Q",
                XmNacceleratorText, xms,
                XmNmnemonic, 'Q',
                NULL );
  XtAddCallback( quitButton, XmNactivateCallback, quitCB, (XtPointer)f );
  XmStringFree( xms );

  /* Help */

  csHelp = XmCreateCascadeButton( f->menubar, "Help", NULL, 0 );
  XtManageChild( csHelp );
  pdHelp = XmCreatePulldownMenu( f->menubar, "Help", NULL, 0 );
  XtVaSetValues( csHelp, XmNsubMenuId, pdHelp,
                         XmNmnemonic, 'H',
                 NULL );

  infoButton = XtCreateManagedWidget( "About...",
                xmPushButtonWidgetClass, pdHelp, NULL, 0 );
  XtAddCallback( infoButton, XmNactivateCallback, infoCB, NULL );

  XtVaSetValues( f->menubar, XmNmenuHelpWidget, csHelp, NULL );

  f->runInXterm = False;
  f->transferType = TRANSFER_BINARY;

  /* Options */

  csOptions = XmCreateCascadeButton( f->menubar, "Options", NULL, 0 );
  XtManageChild( csOptions );
  pdOptions = XmCreatePulldownMenu( f->menubar, "Options", NULL, 0 );
  XtVaSetValues( csOptions, XmNsubMenuId, pdOptions,
                 XmNmnemonic, 'O',
                 NULL );

  if( type == FTP_FILESYSTEM )
  {
    f->transferBinaryTB = XtVaCreateManagedWidget( "Binary Transfer Mode",
		xmToggleButtonWidgetClass, pdOptions,
                XmNset, True,
                NULL );
    XtAddCallback( f->transferBinaryTB, XmNvalueChangedCallback, transferTypeCB,
		(XtPointer)f );
    f->transferAsciiTB = XtVaCreateManagedWidget( "ASCII Transfer Mode",
                xmToggleButtonWidgetClass, pdOptions,
                XmNset, False,
                NULL );
    XtAddCallback( f->transferAsciiTB, XmNvalueChangedCallback, transferTypeCB,
                (XtPointer)f );
  }

  if( type == LOCAL_FILESYSTEM )
  {
    runInXtermToggle = XtVaCreateManagedWidget( "Run Applications In Xterm",
                xmToggleButtonWidgetClass, pdOptions,
                XmNset, False,
                NULL );
    XtAddCallback( runInXtermToggle, XmNvalueChangedCallback, runInXtermCB, (XtPointer)f );

    /* Utilities */

    csUtil = XmCreateCascadeButton( f->menubar, "Utilities", NULL, 0 );
    XtManageChild( csUtil );
    pdUtil = XmCreatePulldownMenu( f->menubar, "Utilities", NULL, 0 );
    XtVaSetValues( csUtil, XmNsubMenuId, pdUtil,
                 XmNmnemonic, 'U',
                 NULL );

    xms = XmStringCreateSimple( "Alt-N" );
    newFileManagerButton = XtVaCreateManagedWidget( "New File Manager...",
                xmPushButtonWidgetClass, pdUtil,
                XmNaccelerator, "Alt<Key>N",
                XmNacceleratorText, xms,
                XmNmnemonic, 'N',
                NULL );
    XtAddCallback( newFileManagerButton, XmNactivateCallback, newFileManagerCB,
                 (XtPointer)f );
    XmStringFree( xms );

#if MAJOR_VERSION >= 2
    xms = XmStringCreateSimple( "Alt-F" );
    ftpFileManagerButton = XtVaCreateManagedWidget( "FTP File Manager...",
                xmPushButtonWidgetClass, pdUtil,
                XmNaccelerator, "Alt<Key>F",
                XmNacceleratorText, xms,
                XmNmnemonic, 'F',
                NULL );
    XtAddCallback( ftpFileManagerButton, XmNactivateCallback, ftpFileManagerCB,
                 (XtPointer)f );
    XmStringFree( xms );
#endif

    xms = XmStringCreateSimple( "Ctrl-R" );
    delAccButton = XtVaCreateManagedWidget( "Remove Clipboard Item...",
                xmPushButtonWidgetClass, pdUtil,
                XmNaccelerator, "Ctrl<Key>R",
                XmNacceleratorText, xms,
                XmNmnemonic, 'R',
                NULL );
    XtAddCallback( delAccButton, XmNactivateCallback, createDelAccelPopup, NULL );
    XmStringFree( xms );

    xms = XmStringCreateSimple( "Alt-E" );
    execCmdButton = XtVaCreateManagedWidget( "Execute Command...",
                xmPushButtonWidgetClass, pdUtil,
                XmNaccelerator, "Alt<Key>E",
                XmNacceleratorText, xms,
                XmNmnemonic, 'E',
                NULL );
    XtAddCallback( execCmdButton, XmNactivateCallback, popupCmdDialog,
                 (XtPointer)NULL );
    XmStringFree( xms );

    configButton = XtVaCreateManagedWidget( "Set Configuration...",
                xmPushButtonWidgetClass, pdUtil,
                NULL );
    XtAddCallback( configButton, XmNactivateCallback, configCB,
                 (XtPointer)NULL );
  }
}

void createToolbar( f, w )
  struct FileManager *f;
  Widget w;
{
  Widget duplicateButton, removeButton, propertiesButton, 
	 mkdirButton, newFMButton, infoButton;
  Widget ftpButton = (Widget)NULL;

  duplicateButton = XtVaCreateManagedWidget( "duplicateButton",
                xmPushButtonWidgetClass, w,
		XmNlabelType, XmPIXMAP,
		XmNtraversalOn, False,
                NULL );
  XtAddCallback( duplicateButton, XmNactivateCallback, duplicateCB, (XtPointer)f );

  removeButton = XtVaCreateManagedWidget( "removeButton",
                xmPushButtonWidgetClass, w,
		XmNlabelType, XmPIXMAP,
		XmNtraversalOn, False,
                NULL );
  XtAddCallback( removeButton, XmNactivateCallback, removeCB, (XtPointer)f );

  propertiesButton = XtVaCreateManagedWidget( "propertiesButton",
                xmPushButtonWidgetClass, w,
		XmNlabelType, XmPIXMAP,
		XmNtraversalOn, False,
                NULL );
  XtAddCallback( propertiesButton, XmNactivateCallback, propertiesCB, (XtPointer)f );

  mkdirButton = XtVaCreateManagedWidget( "mkdirButton",
                xmPushButtonWidgetClass, w,
		XmNlabelType, XmPIXMAP,
		XmNtraversalOn, False,
                NULL );
  XtAddCallback( mkdirButton, XmNactivateCallback, mkdirCB, (XtPointer)f );

#if MAJOR_VERSION >= 2
  ftpButton = XtVaCreateManagedWidget( "ftpButton",
		xmPushButtonWidgetClass, w,
                XmNlabelType, XmPIXMAP,
		XmNtraversalOn, False,
                NULL );
  XtAddCallback( ftpButton, XmNactivateCallback, ftpFileManagerCB, (XtPointer)f );
#endif

  newFMButton = XtVaCreateManagedWidget( "newFMButton",
		xmPushButtonWidgetClass, w,
                XmNlabelType, XmPIXMAP,
		XmNtraversalOn, False,
                NULL );
  XtAddCallback( newFMButton, XmNactivateCallback, newFileManagerCB, (XtPointer)f );

  infoButton = XtVaCreateManagedWidget( "infoButton",
		xmPushButtonWidgetClass, w,
                XmNlabelType, XmPIXMAP,
		XmNtraversalOn, False,
                NULL );
  XtAddCallback( infoButton, XmNactivateCallback, infoCB, NULL );

  setToolBarPixmaps( duplicateButton, removeButton, propertiesButton, 
         mkdirButton, ftpButton, newFMButton, infoButton );
}

/* Callbacks */

void transferTypeCB( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  struct FileManager *f = (struct FileManager *)x1;

  if( w == f->transferAsciiTB )
  {
    f->transferType = TRANSFER_ASCII;
    /* ftpSendCommand( "MODE" */
  }
  else if( w == f->transferBinaryTB )
  {
    f->transferType = TRANSFER_BINARY;
  }
}

void newFileManagerCB( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  struct FileManager *f = (struct FileManager *)x1;
  allocateFileManager( (Widget)NULL, LOCAL_FILESYSTEM, "", "", "" );
}

void ftpFileManagerCB( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  Widget dlg, parent, rc, tf3;
  Widget label1, label2, label3;
  XmString t = XmStringCreateSimple( "FTP Host Name:" ),
           title = XmStringCreateSimple( "FTP" );
  Arg args[3];

  XtSetArg( args[0], XmNselectionLabelString, t );
  XtSetArg( args[1], XmNautoUnmanage, True );
  XtSetArg( args[2], XmNdialogTitle, title );
  dlg = XmCreatePromptDialog( w, "promptDlg", args, 3 );
  XmStringFree( t );
  XmStringFree( title );

  parent = XtParent( XmSelectionBoxGetChild( dlg, XmDIALOG_TEXT ) );
  XtUnmanageChild( XmSelectionBoxGetChild( dlg, XmDIALOG_TEXT ) );
  XtUnmanageChild( XmSelectionBoxGetChild( dlg, XmDIALOG_SELECTION_LABEL ) );

  rc = XtVaCreateManagedWidget( "rc",
		xmRowColumnWidgetClass, parent,
		XmNnumColumns, 2,
		XmNorientation, XmVERTICAL,
		NULL );

  label1 = XtVaCreateManagedWidget( "Host Name:",
		xmLabelWidgetClass, rc,
		XmNheight, 30,
		NULL );
  tf1 = XtVaCreateManagedWidget( "tf1",
		xmTextFieldWidgetClass, rc,
                XmNheight, 30,
                NULL );
  XtAddCallback( tf1, XmNactivateCallback, traverseCB, NULL );

  label2 = XtVaCreateManagedWidget( "User Name:",
                xmLabelWidgetClass, rc,
                XmNheight, 30,
                NULL );
  tf2 = XtVaCreateManagedWidget( "tf2",
                xmTextFieldWidgetClass, rc,
                XmNheight, 30,
                NULL );
  XtAddCallback( tf2, XmNactivateCallback, traverseCB, NULL );

  label3 = XtVaCreateManagedWidget( "Password:",
                xmLabelWidgetClass, rc,
                XmNheight, 30,
                NULL );
  tf3 = XtVaCreateManagedWidget( "tf3",
                xmTextFieldWidgetClass, rc,
                XmNheight, 30,
                NULL );
  XtAddCallback( tf3, XmNmodifyVerifyCallback, passwordCB, NULL );

  strcpy( tmpPassword, "" );

  XtAddCallback( dlg, XmNokCallback, ftpFileManagerOKCB, NULL );
  XtUnmanageChild( XmSelectionBoxGetChild( dlg, XmDIALOG_HELP_BUTTON ) );

  XtManageChild( dlg );
  XtPopup( XtParent(dlg), XtGrabExclusive );
}

void passwordCB( w, xtp1, xtp2 )
  Widget w;
  XtPointer xtp1, xtp2;
{
  XmTextVerifyCallbackStruct *cbs = (XmTextVerifyCallbackStruct *)xtp2;
  int i;

  if( cbs->text->ptr == NULL )
  {
     /* backspace */
     cbs->endPos = strlen( tmpPassword );
     tmpPassword[cbs->startPos] = 0;
     return;
  }

  if( cbs->text->length > 1 )
  {
     /* disallow paste operations */
     cbs->doit = False;
     return;
  }

  strncat( tmpPassword, cbs->text->ptr, cbs->text->length );
  tmpPassword[ cbs->endPos + cbs->text->length ] = 0;
 
  for( i = 0; i < cbs->text->length; i++ )
        cbs->text->ptr[i] = '*';
}

void ftpFileManagerOKCB( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  char *host, *name;

  host = XmTextFieldGetString( tf1 );
  name = XmTextFieldGetString( tf2 );

  if( !strcmp( host, "" ) )
  {
    popupErrorDialog( "Host Name Cannot Be NULL..." );
    XtFree( name );
    return;
  }
  if( !strcmp( name, "" ) )
  {
    popupErrorDialog( "Host Name Cannot Be NULL..." );
    XtFree( host );
    return;
  }
  if( !strcmp( tmpPassword, "" ) )
  {
    popupErrorDialog( "Host Name Cannot Be NULL..." );
    XtFree( host );
    XtFree( name );
    return;
  }

  allocateFileManager( (Widget)NULL, FTP_FILESYSTEM, host, name, tmpPassword );

  XtFree( name );
  XtFree( host );
}

void quitCB( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  struct FileManager *f = (struct FileManager *)x1;

  if( f->type == FTP_FILESYSTEM && f->cmdSocketId )  
    ftpSendCommand( f, "QUIT", -1, "" );
  else
    deleteFileManager( f->mainForm );
} 

void infoCB( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  static Widget dialog = NULL;
  XmString xms;
  Arg args[1];

  if( !dialog )
  {
    xms = XmStringCreateLtoR( "mfm - version 1.3\nCreated By Andrew T. Renalds", XmSTRING_DEFAULT_CHARSET );
    XtSetArg( args[0], XmNmessageString, xms );

    dialog = XmCreateInformationDialog( w, "infoDialog", args, 1 );
    XtVaSetValues( XtParent(dialog), XtNtitle, "Information", NULL );
    XtUnmanageChild( XmMessageBoxGetChild(dialog,XmDIALOG_CANCEL_BUTTON) );
    XtUnmanageChild( XmMessageBoxGetChild(dialog,XmDIALOG_HELP_BUTTON) );

    XmStringFree( xms );
  }

  if( !XtIsManaged(dialog) )
  {
    XtManageChild( dialog );
    XtPopup( XtParent(dialog), XtGrabExclusive );
  }
  XRaiseWindow( XtDisplay(dialog), XtWindow(dialog) );
}

void runInXtermCB( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  struct FileManager *f = (struct FileManager *)x1;
  XtVaGetValues( w, XmNset, &f->runInXterm, NULL );
}

void mkdirCB( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  Widget dlg;
  XmString t = XmStringCreateSimple( "Enter New Directory Name:" ),
           title = XmStringCreateSimple( "New Directory" );
  Arg args[3];

  XtSetArg( args[0], XmNselectionLabelString, t );
  XtSetArg( args[1], XmNautoUnmanage, True );
  XtSetArg( args[2], XmNdialogTitle, title );
  dlg = XmCreatePromptDialog( w, "promptDlg", args, 3 );
  XmStringFree( t );
  XmStringFree( title );

  XtAddCallback( dlg, XmNokCallback, doMkdir, x1 );
  XtUnmanageChild( XmSelectionBoxGetChild( dlg, XmDIALOG_HELP_BUTTON ) );

  XtManageChild( dlg );
  XtPopup( XtParent(dlg), XtGrabExclusive );
}

void doMkdir( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  struct FileManager *f = (struct FileManager *)x1;
  XmSelectionBoxCallbackStruct *cbs = (XmSelectionBoxCallbackStruct *)x2;
  char *cmd, *dirName;
  struct DirInfo *dirInfo = getIthDir( f->dirInfo, f->nDirInfo-1 );

  XmStringGetLtoR( cbs->value, XmSTRING_DEFAULT_CHARSET, &dirName );
  if( !strcmp( dirName, "" ) )
  {
    popupErrorDialog( "Directory Name Cannot Be NULL..." );
    return;
  }

  cmd = (char *)XtMalloc( strlen(dirName) + 25 +
		strlen(dirInfo->di.dragName) );
  if( !strcmp( dirInfo->di.dragName, "/" ) )
    sprintf( cmd, "mkdir -p /%s 2>&1", dirName );
  else
    sprintf( cmd, "mkdir -p %s/%s 2>&1", dirInfo->di.dragName, dirName );

  XtFree( (char *)dirName );
  XtFree( (char *)cmd );

  if( issuePipeCommand( cmd ) )
  {
    XtFree( (char *)cmd );
    return;
  }

  updateAllFileManagers();
}

void duplicateCB( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  struct FileManager *f = (struct FileManager *)x1;
  struct DirInfo *dirInfo = getIthDir( f->dirInfo, f->nDirInfo-1 );
  char buffer[256], *ptr, *ptrBuffer, *cmd;

  ptrBuffer = (char *)XtMalloc( strlen(dirInfo->di.dragName)+1 );
  strcpy( ptrBuffer, dirInfo->di.dragName );
  ptr = ptrBuffer;

  while( sscanf( ptr, "%s", buffer ) == 1 )
  {
    char *newFileName = (char *)XtMalloc( strlen(buffer) + 10 );
    sprintf( newFileName, "%s_copy", buffer );
    while( access( newFileName, F_OK ) != -1 )  strcat( newFileName, "0" );

    cmd = (char *)XtMalloc( strlen(buffer) + strlen(newFileName) + 15 );
    sprintf( cmd, "cp -r %s %s 2>&1", buffer, newFileName );
    if( issuePipeCommand( cmd ) )
    {
      XtFree( (char *)ptrBuffer );
      XtFree( (char *)cmd );
      XtFree( (char *)newFileName );
      return;
    }

    XtFree( (char *)cmd );
    XtFree( (char *)newFileName );

    ptr += strlen( buffer );
    while( ptr[0] == ' ' )  ptr++;
    memset( (void *)buffer, '\0', sizeof(buffer) );
  }

  XtFree( (char *)ptrBuffer );

  updateAllFileManagers();
}

void removeCB( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  Widget dlg;
  XmString xms = XmStringCreateSimple( "Are You Sure You Want To Delete This?" );
  XmString title = XmStringCreateSimple( "Delete?" );

  dlg = XmCreateQuestionDialog( w, "deleteDialog", NULL, 0 );
  XtVaSetValues( dlg,
	XmNdialogTitle, title,
	XmNmessageString, xms,
	NULL );
  XtAddCallback( dlg, XmNokCallback, removeOKCB, x1 );
  XtUnmanageChild( XmMessageBoxGetChild(dlg,XmDIALOG_HELP_BUTTON) );

  XmStringFree( xms );
  XmStringFree( title );

  XtManageChild( dlg );
  XtPopup( XtParent(dlg), XtGrabExclusive );
}

void removeOKCB( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  struct FileManager *f = (struct FileManager *)x1;
  struct DirInfo *dirInfo = getIthDir( f->dirInfo, f->nDirInfo-1 );
  char buffer[256], *ptr, *ptrBuffer, *cmd;

  ptrBuffer = (char *)XtMalloc( strlen(dirInfo->di.dragName)+1 );
  strcpy( ptrBuffer, dirInfo->di.dragName );
  ptr = ptrBuffer;

  while( sscanf( ptr, "%s", buffer ) == 1 )
  {
    cmd = (char *)XtMalloc( strlen(buffer) + strlen(buffer) + 15 );
    sprintf( cmd, "rm -rf %s 2>&1", buffer );
    if( issuePipeCommand( cmd ) )
    {
      XtFree( (char *)ptrBuffer );
      XtFree( (char *)cmd );
      return;
    }
    XtFree( (char *)cmd );

    ptr += strlen( buffer );
    while( ptr[0] == ' ' )  ptr++;
    memset( (void *)buffer, '\0', sizeof(buffer) );
  }
  
  XtFree( (char *)ptrBuffer );

  updateAllFileManagers();
}

void updateCB( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  updateFileManager( (struct FileManager *)x1 );
}

void updateAllCB( w, x1, x2 )
  Widget w;
  XtPointer x1, x2;
{
  updateAllFileManagers();
}
